--[[
-- Debris Class
-- Debris are the little pieces that fall when a Block, a Guardian or the Player are destroyed by an Explosion
-- These little pieces bounce around (using collision:getBounce()) until their internal timer (self.lived)
-- expires. Then they simply disappear.
--]]

local Debris = class:extend("Debris")--Entity:extend("Debris")

local minSize = .5
local maxSize = 2.5
local minVel = -350
local maxVel = (-1 * minVel)
local bounciness = 0.1

--something is wrong here, runs slooow, freezes game
function Debris:__init__(kwargs)
  kwargs.w,kwargs.h = 
    math.random(minSize, maxSize), math.random(minSize, maxSize)
  local map = kwargs.map
  
    self.x = kwargs.x or 0
    self.y = kwargs.y or 0
    self.h = kwargs.h or 16
    self.w = kwargs.w or 16
    self.oldx = 0
    self.oldy =0
    map:add(self)
    self.map = map
      self.weight = 400
    self.gravity = 0
    self.initGravity = 500/2
    
  self.elasticity = bounciness

  self.r, self.g, self.b = kwargs.r,kwargs.g,kwargs.b
  if kwargs.color then
      self.color = kwargs.color
      local col = self.color
      self.r, self.g, self.b = col[1],col[2],col[3]
  end
  self.lifeTime = 1 + 3 * math.random()
  self.lived = 0
  local minVel = kwargs.minVel or minVel
  local maxVel = kwargs.maxVel or maxVel
  self.vx = math.random(minVel, maxVel)
  self.vy = math.random(minVel, maxVel) --log("woo")
  self.isBackground = true
  
  self.drawBlood = 0
  self.shadows = {}
end

function Debris:destroy()
    self.map:remove(self)
end

function Debris:update(dt)
  self.lived = self.lived + dt
    local collided = circleVsRect(main_circle.x, main_circle.y, main_circle.radius,
  self.x, self.y, self.w, self.h)
   self.oldx, self.oldy = self.x, self.y
  if not collided or  self.lived >= self.lifeTime  then
    self:destroy()
  else
    self:updateGravity(dt)
    --self:moveColliding(dt)
  end
  if math.random(1,100)>90 and collided then--self.oldx then
  	love.graphics.setCanvas(path_canvas)
	love.graphics.setLineWidth( 1 )
  local r,g,b,a = love.graphics.getColor()
  love.graphics.setColor(self.color)
  love.graphics.line(self.oldx,self.oldy,self.x,self.y)
  love.graphics.setColor(r,g,b,a)
  love.graphics.setCanvas()
  end

end

function Debris:updateGravity(dt)
    
    self.gravity = self.gravity+self.weight*dt
    local gravity = self.gravity
    self.vy = self.vy + gravity*dt
    
   self.x = self.x + self.vx * dt
   self.y = self.y + self.vy * dt
 end

function Debris:draw()

  util.drawFilledRectangle(self.x, self.y, self.w, self.h, self.r, self.g, self.b)
end

return Debris
